// 2. Callback aprs appel de thread (mthode avec couteurs)
//	(sparation du demandeur et des receveurs)


//	Client

import java.util.*;
import java.io.*;
import java.security.*;


public class CbDigest implements Runnable {
	private File input;
	private Vector digestList = new Vector();	// liste d'abonnes

	public CbDigest (File input) {
		this.input = input;
	}

	public synchronized void addListener(DigestListener dl) {
		digestList.add(dl);
	}

	public synchronized void removeListener(DigestListener dl){
		digestList.remove(dl);
	}

	private synchronized void sendDigest(byte[] digest) {
		ListIterator iterator = digestList.listIterator();
		while(iterator.hasNext()) {
			DigestListener dl = (DigestListener) iterator.next();
			dl.setDigest(digest);
		}
	}

	public void run() {
		try {
			MessageDigest sha = MessageDigest.getInstance("SHA");
			DigestInputStream din = new DigestInputStream(
				new FileInputStream(input),
				sha
			);
			int b;
			while ((b = din.read()) != -1);
			din.close();
			byte[] digest = sha.digest();
			sendDigest(digest);		// diffusion
		}
		catch(IOException e) {
			System.err.println(e);
		}
		catch(NoSuchAlgorithmException  e) {
			System.err.println(e);
		}
	}
}

