// 4. Attente entre threads via ressources : wait()

//	Serveur


import java.io.*;

public class CbDigestServer {
	private File input;
	private byte[] digest;

	public CbDigestServer(File input) {
		this.input = input;
	}

	public void setDigest(byte[] digest) {
		this.digest = digest;
	}

	public String toString() {
		String result = input.getName() + ": ";
		if (digest != null) {
			for (int i = 0; i< digest.length; i++) {
				result += digest[i] + " ";
			}
		}
		else {
			result += "unusable digest";
		}
		return result;
	}

	public void calculateDigest() {
	  synchronized(this) {
		CbDigest cb = new CbDigest(input, this);
						// this = objet d'attente
		Thread t = new Thread(cb);	// appel du thread
		t.start();
		try {
			wait();
		}
		catch (InterruptedException e) {
			// thread interrompu avant la fin du calcul
		}
		System.out.println(this);	// la signature est maintenant connue
	  }
	}

	public static void main(String args[]) {
		for (int i = 0; i< args.length; i++) {
			File f = new File(args[i]);
			CbDigestServer d = new CbDigestServer(f);
			d.calculateDigest();
		}
	}
}

